#include <config.h>
/* window.c generated by valac 0.56.3, the Vala compiler
 * generated from window.vala, do not modify */

/* tarot implements the rules of the tarot game*/
/* Copyright (C) 2019, 2020, 2024  Vivien Kraus*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, version 3 of the License.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

#include "tarot_app.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include "tarot-gobject.h"
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <gdk/gdk.h>

typedef GDBusProxy TarotFileManagerInterfaceProxy;
typedef GDBusProxyClass TarotFileManagerInterfaceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TAROT_TYPE_EVENT_QUEUE (tarot_event_queue_get_type ())
#define TAROT_EVENT_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TAROT_TYPE_EVENT_QUEUE, TarotEventQueue))
#define TAROT_EVENT_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TAROT_TYPE_EVENT_QUEUE, TarotEventQueueClass))
#define TAROT_IS_EVENT_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TAROT_TYPE_EVENT_QUEUE))
#define TAROT_IS_EVENT_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TAROT_TYPE_EVENT_QUEUE))
#define TAROT_EVENT_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TAROT_TYPE_EVENT_QUEUE, TarotEventQueueClass))

typedef struct _TarotEventQueue TarotEventQueue;
typedef struct _TarotEventQueueClass TarotEventQueueClass;
typedef struct _TarotEventQueuePrivate TarotEventQueuePrivate;
#define __vala_TarotGameEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGameEvent_free (var), NULL)))
typedef struct _TarotParamSpecEventQueue TarotParamSpecEventQueue;
enum  {
	TAROT_EVENT_QUEUE_NEW_EVENT_SIGNAL,
	TAROT_EVENT_QUEUE_CATCHUP_SIGNAL,
	TAROT_EVENT_QUEUE_NUM_SIGNALS
};
static guint tarot_event_queue_signals[TAROT_EVENT_QUEUE_NUM_SIGNALS] = {0};
enum  {
	TAROT_WINDOW_0_PROPERTY,
	TAROT_WINDOW_NUM_PROPERTIES
};
static GParamSpec* tarot_window_properties[TAROT_WINDOW_NUM_PROPERTIES];
#define __vala_TarotSolo_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotSolo_free (var), NULL)))
#define _tarot_event_queue_unref0(var) ((var == NULL) ? NULL : (var = (tarot_event_queue_unref (var), NULL)))
#define __vala_TarotGame_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGame_free (var), NULL)))
#define __vala_TarotGameIterator_free0(var) ((var == NULL) ? NULL : (var = (_vala_TarotGameIterator_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TarotEventQueue {
	GTypeInstance parent_instance;
	volatile int ref_count;
	TarotEventQueuePrivate * priv;
};

struct _TarotEventQueueClass {
	GTypeClass parent_class;
	void (*finalize) (TarotEventQueue *self);
};

struct _TarotEventQueuePrivate {
	TarotGameEvent* m_data[256];
	gsize m_head;
	gsize m_n;
	gboolean timer_running;
	gboolean deleted;
	gdouble next_delay;
};

struct _TarotParamSpecEventQueue {
	GParamSpec parent_instance;
};

struct _TarotWindowPrivate {
	GtkStack* pages;
	TarotWidget* tarot_widget;
	GtkListBox* page_select_players;
	GtkButton* button_new_game;
	GtkPopoverMenu* menu_popover;
	TarotSolo* my_game;
	TarotEventQueue* m_queue;
	gsize n_events_pulled;
	TarotGame* game_shown;
};

static gint TarotEventQueue_private_offset;
static gpointer tarot_event_queue_parent_class = NULL;
static gint TarotWindow_private_offset;
static gpointer tarot_window_parent_class = NULL;

static GType tarot_file_manager_interface_get_type_once (void);
static void tarot_file_manager_interface_proxy_g_signal (GDBusProxy* proxy,
                                                  const gchar* sender_name,
                                                  const gchar* signal_name,
                                                  GVariant* parameters);
static void tarot_file_manager_interface_proxy_ShowFolders (TarotFileManagerInterface* self,
                                                     gchar** URIs,
                                                     gint URIs_length1,
                                                     const gchar* StartupId,
                                                     GError** error);
static void tarot_file_manager_interface_proxy_tarot_file_manager_interface_interface_init (TarotFileManagerInterfaceIface* iface);
static void _dbus_tarot_file_manager_interface_ShowFolders (TarotFileManagerInterface* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void tarot_file_manager_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                              const gchar* sender,
                                                              const gchar* object_path,
                                                              const gchar* interface_name,
                                                              const gchar* method_name,
                                                              GVariant* parameters,
                                                              GDBusMethodInvocation* invocation,
                                                              gpointer user_data);
static GVariant* tarot_file_manager_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                                    const gchar* sender,
                                                                    const gchar* object_path,
                                                                    const gchar* interface_name,
                                                                    const gchar* property_name,
                                                                    GError** error,
                                                                    gpointer user_data);
static gboolean tarot_file_manager_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                                   const gchar* sender,
                                                                   const gchar* object_path,
                                                                   const gchar* interface_name,
                                                                   const gchar* property_name,
                                                                   GVariant* value,
                                                                   GError** error,
                                                                   gpointer user_data);
static void _tarot_file_manager_interface_unregister_object (gpointer user_data);
VALA_EXTERN gpointer tarot_event_queue_ref (gpointer instance);
VALA_EXTERN void tarot_event_queue_unref (gpointer instance);
VALA_EXTERN GParamSpec* tarot_param_spec_event_queue (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void tarot_value_set_event_queue (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void tarot_value_take_event_queue (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer tarot_value_get_event_queue (const GValue* value);
VALA_EXTERN GType tarot_event_queue_get_type (void) G_GNUC_CONST ;
static void _vala_TarotGameEvent_free (TarotGameEvent* self);
static void tarot_event_queue_start_timer (TarotEventQueue* self);
static gboolean __lambda30_ (TarotEventQueue* self);
static void tarot_event_queue_dequeue (TarotEventQueue* self);
static gboolean ___lambda30__gsource_func (gpointer self);
VALA_EXTERN void tarot_event_queue_enqueue (TarotEventQueue* self,
                                TarotGameEvent* e);
static TarotGameEvent* _vala_TarotGameEvent_copy (TarotGameEvent* self);
VALA_EXTERN void tarot_event_queue_close (TarotEventQueue* self);
VALA_EXTERN gboolean tarot_event_queue_empty (TarotEventQueue* self);
VALA_EXTERN TarotEventQueue* tarot_event_queue_new (void);
VALA_EXTERN TarotEventQueue* tarot_event_queue_construct (GType object_type);
static void tarot_event_queue_finalize (TarotEventQueue * obj);
static GType tarot_event_queue_get_type_once (void);
static void _vala_TarotSolo_free (TarotSolo* self);
static void _vala_TarotGame_free (TarotGame* self);
static void tarot_window_update_events (TarotWindow* self);
static void _vala_TarotGameIterator_free (TarotGameIterator* self);
static void tarot_window_check_if_next (TarotWindow* self);
static void tarot_window_on_server_event (TarotWindow* self,
                                   TarotGameEvent* ev);
static void tarot_window_show_new_game_page (TarotWindow* self);
static void _tarot_window_on_server_event_tarot_event_queue_new_event (TarotEventQueue* _sender,
                                                                TarotGameEvent* e,
                                                                gpointer self);
static void __lambda31_ (TarotWindow* self);
static void ___lambda31__tarot_event_queue_catchup (TarotEventQueue* _sender,
                                             gpointer self);
static void _tarot_window_show_new_game_page_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void tarot_window_new_game_3p (TarotWindow* self);
static void tarot_window_start_new_game (TarotWindow* self,
                                  gsize n_players,
                                  gboolean with_call,
                                  gchar* seed);
static void _tarot_window_new_game_3p_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_window_new_game_4p (TarotWindow* self);
static void _tarot_window_new_game_4p_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_window_new_game_5p (TarotWindow* self);
static void _tarot_window_new_game_5p_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self);
static void tarot_window_open_info_dialog (TarotWindow* self);
static void _tarot_window_open_info_dialog_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void tarot_window_show_menu_popover (TarotWindow* self);
static void _tarot_window_show_menu_popover_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self);
static gboolean tarot_window_starts_with (const gchar* s,
                                   const gchar* prefix);
static GObject * tarot_window_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _tarot_window___lambda32_ (TarotWindow* self,
                                TarotBid bid);
static void __tarot_window___lambda32__tarot_widget_select_bid (TarotWidget* _sender,
                                                         TarotBid bid,
                                                         gpointer self);
static void _tarot_window___lambda33_ (TarotWindow* self,
                                gboolean decl);
static void __tarot_window___lambda33__tarot_widget_select_declaration (TarotWidget* _sender,
                                                                 gboolean decl,
                                                                 gpointer self);
static void _tarot_window___lambda34_ (TarotWindow* self,
                                guint card);
static void __tarot_window___lambda34__tarot_widget_select_call (TarotWidget* _sender,
                                                          guint call,
                                                          gpointer self);
static void _tarot_window___lambda35_ (TarotWindow* self,
                                guint* cards,
                                gint cards_length1);
static void __tarot_window___lambda35__tarot_widget_select_discard (TarotWidget* _sender,
                                                             guint* discard,
                                                             gint discard_length1,
                                                             gpointer self);
static void _tarot_window___lambda36_ (TarotWindow* self,
                                guint* cards,
                                gint cards_length1);
static void __tarot_window___lambda36__tarot_widget_select_handful (TarotWidget* _sender,
                                                             guint* handful,
                                                             gint handful_length1,
                                                             gpointer self);
static void _tarot_window___lambda37_ (TarotWindow* self,
                                guint card);
static void __tarot_window___lambda37__tarot_widget_select_card (TarotWidget* _sender,
                                                          guint card,
                                                          gpointer self);
static void tarot_window_finalize (GObject * obj);
static GType tarot_window_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _tarot_file_manager_interface_dbus_arg_info_ShowFolders_URIs = {-1, "URIs", "as", NULL};
static const GDBusArgInfo _tarot_file_manager_interface_dbus_arg_info_ShowFolders_StartupId = {-1, "StartupId", "s", NULL};
static const GDBusArgInfo * const _tarot_file_manager_interface_dbus_arg_info_ShowFolders_in[] = {&_tarot_file_manager_interface_dbus_arg_info_ShowFolders_URIs, &_tarot_file_manager_interface_dbus_arg_info_ShowFolders_StartupId, NULL};
static const GDBusArgInfo * const _tarot_file_manager_interface_dbus_arg_info_ShowFolders_out[] = {NULL};
static const GDBusMethodInfo _tarot_file_manager_interface_dbus_method_info_ShowFolders = {-1, "ShowFolders", (GDBusArgInfo **) (&_tarot_file_manager_interface_dbus_arg_info_ShowFolders_in), (GDBusArgInfo **) (&_tarot_file_manager_interface_dbus_arg_info_ShowFolders_out), NULL};
static const GDBusMethodInfo * const _tarot_file_manager_interface_dbus_method_info[] = {&_tarot_file_manager_interface_dbus_method_info_ShowFolders, NULL};
static const GDBusSignalInfo * const _tarot_file_manager_interface_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _tarot_file_manager_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _tarot_file_manager_interface_dbus_interface_info = {-1, "org.freedesktop.FileManager1", (GDBusMethodInfo **) (&_tarot_file_manager_interface_dbus_method_info), (GDBusSignalInfo **) (&_tarot_file_manager_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_tarot_file_manager_interface_dbus_property_info), NULL};
static const GDBusInterfaceVTable _tarot_file_manager_interface_dbus_interface_vtable = {tarot_file_manager_interface_dbus_interface_method_call, tarot_file_manager_interface_dbus_interface_get_property, tarot_file_manager_interface_dbus_interface_set_property};

void
tarot_file_manager_interface_ShowFolders (TarotFileManagerInterface* self,
                                          gchar** URIs,
                                          gint URIs_length1,
                                          const gchar* StartupId,
                                          GError** error)
{
	TarotFileManagerInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = TAROT_FILE_MANAGER_INTERFACE_GET_INTERFACE (self);
	if (_iface_->ShowFolders) {
		_iface_->ShowFolders (self, URIs, URIs_length1, StartupId, error);
	}
}

static void
tarot_file_manager_interface_default_init (TarotFileManagerInterfaceIface * iface,
                                           gpointer iface_data)
{
}

static GType
tarot_file_manager_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TarotFileManagerInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_file_manager_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType tarot_file_manager_interface_type_id;
	tarot_file_manager_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "TarotFileManagerInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (tarot_file_manager_interface_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (tarot_file_manager_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) tarot_file_manager_interface_proxy_get_type);
	g_type_set_qdata (tarot_file_manager_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.FileManager1");
	g_type_set_qdata (tarot_file_manager_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_tarot_file_manager_interface_dbus_interface_info));
	g_type_set_qdata (tarot_file_manager_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) tarot_file_manager_interface_register_object);
	return tarot_file_manager_interface_type_id;
}

GType
tarot_file_manager_interface_get_type (void)
{
	static volatile gsize tarot_file_manager_interface_type_id__once = 0;
	if (g_once_init_enter (&tarot_file_manager_interface_type_id__once)) {
		GType tarot_file_manager_interface_type_id;
		tarot_file_manager_interface_type_id = tarot_file_manager_interface_get_type_once ();
		g_once_init_leave (&tarot_file_manager_interface_type_id__once, tarot_file_manager_interface_type_id);
	}
	return tarot_file_manager_interface_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (TarotFileManagerInterfaceProxy, tarot_file_manager_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TAROT_TYPE_FILE_MANAGER_INTERFACE, tarot_file_manager_interface_proxy_tarot_file_manager_interface_interface_init) )
static void
tarot_file_manager_interface_proxy_class_init (TarotFileManagerInterfaceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = tarot_file_manager_interface_proxy_g_signal;
}

static void
tarot_file_manager_interface_proxy_g_signal (GDBusProxy* proxy,
                                             const gchar* sender_name,
                                             const gchar* signal_name,
                                             GVariant* parameters)
{
}

static void
tarot_file_manager_interface_proxy_init (TarotFileManagerInterfaceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_tarot_file_manager_interface_dbus_interface_info));
}

static void
tarot_file_manager_interface_proxy_ShowFolders (TarotFileManagerInterface* self,
                                                gchar** URIs,
                                                gint URIs_length1,
                                                const gchar* StartupId,
                                                GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp0_;
	GVariantBuilder _tmp1_;
	gint _tmp2_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.FileManager1", "ShowFolders");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_tmp0_ = URIs;
	g_variant_builder_init (&_tmp1_, G_VARIANT_TYPE ("as"));
	for (_tmp2_ = 0; _tmp2_ < URIs_length1; _tmp2_++) {
		g_variant_builder_add_value (&_tmp1_, g_variant_new_string (*_tmp0_));
		_tmp0_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp1_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (StartupId));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
tarot_file_manager_interface_proxy_tarot_file_manager_interface_interface_init (TarotFileManagerInterfaceIface* iface)
{
	iface->ShowFolders = tarot_file_manager_interface_proxy_ShowFolders;
}

static void
_dbus_tarot_file_manager_interface_ShowFolders (TarotFileManagerInterface* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar** URIs = NULL;
	gint URIs_length1 = 0;
	GVariant* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length;
	gint _tmp4__size;
	gint _tmp4__length1;
	GVariantIter _tmp5_;
	GVariant* _tmp6_;
	gchar* StartupId = NULL;
	GVariant* _tmp7_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp4_ = g_new (gchar*, 5);
	_tmp4__length = 0;
	_tmp4__size = 4;
	_tmp4__length1 = 0;
	g_variant_iter_init (&_tmp5_, _tmp3_);
	for (; (_tmp6_ = g_variant_iter_next_value (&_tmp5_)) != NULL; _tmp4__length1++) {
		if (_tmp4__size == _tmp4__length) {
			_tmp4__size = 2 * _tmp4__size;
			_tmp4_ = g_renew (gchar*, _tmp4_, _tmp4__size + 1);
		}
		_tmp4_[_tmp4__length++] = g_variant_dup_string (_tmp6_, NULL);
		g_variant_unref (_tmp6_);
	}
	URIs_length1 = _tmp4__length1;
	_tmp4_[_tmp4__length] = NULL;
	URIs = _tmp4_;
	g_variant_unref (_tmp3_);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	StartupId = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	tarot_file_manager_interface_ShowFolders (self, URIs, URIs_length1, StartupId, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	URIs = (_vala_array_free (URIs, URIs_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (StartupId);
	;
}

static void
tarot_file_manager_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* method_name,
                                                         GVariant* parameters,
                                                         GDBusMethodInvocation* invocation,
                                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "ShowFolders") == 0) {
		_dbus_tarot_file_manager_interface_ShowFolders (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
tarot_file_manager_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GError** error,
                                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
tarot_file_manager_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                          const gchar* sender,
                                                          const gchar* object_path,
                                                          const gchar* interface_name,
                                                          const gchar* property_name,
                                                          GVariant* value,
                                                          GError** error,
                                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
tarot_file_manager_interface_register_object (gpointer object,
                                              GDBusConnection* connection,
                                              const gchar* path,
                                              GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_tarot_file_manager_interface_dbus_interface_info), &_tarot_file_manager_interface_dbus_interface_vtable, data, _tarot_file_manager_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_tarot_file_manager_interface_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
tarot_event_queue_get_instance_private (TarotEventQueue* self)
{
	return G_STRUCT_MEMBER_P (self, TarotEventQueue_private_offset);
}

static void
_vala_TarotGameEvent_free (TarotGameEvent* self)
{
	g_boxed_free (tarot_game_event_get_type (), self);
}

static gboolean
__lambda30_ (TarotEventQueue* self)
{
	gboolean result;
	self->priv->timer_running = FALSE;
	if (!self->priv->deleted) {
		tarot_event_queue_dequeue (self);
	}
	result = FALSE;
	return result;
}

static gboolean
___lambda30__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda30_ ((TarotEventQueue*) self);
	return result;
}

static void
tarot_event_queue_start_timer (TarotEventQueue* self)
{
	gdouble seconds = 0.0;
	TarotGameEvent* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->timer_running = TRUE;
	seconds = self->priv->next_delay;
	self->priv->next_delay = (gdouble) 1;
	_tmp0_ = self->priv->m_data[self->priv->m_head];
	switch (tarot_game_event_type (_tmp0_)) {
		case TAROT_SETUP_EVENT:
		case TAROT_DEAL_EVENT:
		case TAROT_BID_EVENT:
		case TAROT_DECL_EVENT:
		{
			self->priv->next_delay = (gdouble) 0;
			break;
		}
		case TAROT_DOG_EVENT:
		{
			self->priv->next_delay = (gdouble) 3;
			break;
		}
		case TAROT_HANDFUL_EVENT:
		{
			TarotCard* cards = NULL;
			TarotCard* _tmp1_;
			gint cards_length1;
			gint _cards_size_;
			TarotGameEvent* _tmp2_;
			TarotCard* _tmp3_ = NULL;
			gsize _tmp4_ = 0;
			TarotGameEventError _tmp5_;
			TarotCard* _tmp6_;
			gint _tmp6__length1;
			_tmp1_ = g_new0 (TarotCard, 0);
			cards = _tmp1_;
			cards_length1 = 0;
			_cards_size_ = cards_length1;
			_tmp2_ = self->priv->m_data[self->priv->m_head];
			_tmp5_ = tarot_game_event_get_handful_alloc (_tmp2_, &_tmp4_, &_tmp3_);
			cards = (g_free (cards), NULL);
			cards = _tmp3_;
			cards_length1 = _tmp4_;
			_cards_size_ = cards_length1;
			if (_tmp5_ != TAROT_EVENT_OK) {
				_vala_assert (FALSE, "false");
			}
			_tmp6_ = cards;
			_tmp6__length1 = cards_length1;
			if (_tmp6__length1 != 0) {
				self->priv->next_delay = (gdouble) 3;
			} else {
				self->priv->next_delay = (gdouble) 0;
			}
			cards = (g_free (cards), NULL);
			break;
		}
		default:
		{
			self->priv->next_delay = (gdouble) 1;
			break;
		}
	}
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (1000 * seconds), ___lambda30__gsource_func, tarot_event_queue_ref (self), tarot_event_queue_unref);
}

static void
tarot_event_queue_dequeue (TarotEventQueue* self)
{
	TarotGameEvent* _tmp0_;
	gsize _tmp1_;
	gsize _tmp2_;
	g_return_if_fail (self != NULL);
	_vala_assert (self->priv->m_n > ((gsize) 0), "m_n > 0");
	_tmp0_ = self->priv->m_data[self->priv->m_head];
	g_signal_emit (self, tarot_event_queue_signals[TAROT_EVENT_QUEUE_NEW_EVENT_SIGNAL], 0, _tmp0_);
	_tmp1_ = self->priv->m_head;
	self->priv->m_head = _tmp1_ + 1;
	_tmp2_ = self->priv->m_n;
	self->priv->m_n = _tmp2_ - 1;
	self->priv->m_head = self->priv->m_head % 256;
	if (self->priv->m_n > ((gsize) 0)) {
		_vala_assert (!self->priv->timer_running, "!timer_running");
		tarot_event_queue_start_timer (self);
	} else {
		g_signal_emit (self, tarot_event_queue_signals[TAROT_EVENT_QUEUE_CATCHUP_SIGNAL], 0);
	}
}

static TarotGameEvent*
_vala_TarotGameEvent_copy (TarotGameEvent* self)
{
	return g_boxed_copy (tarot_game_event_get_type (), self);
}

static gpointer
__vala_TarotGameEvent_copy0 (gpointer self)
{
	return self ? _vala_TarotGameEvent_copy (self) : NULL;
}

void
tarot_event_queue_enqueue (TarotEventQueue* self,
                           TarotGameEvent* e)
{
	gsize i = 0UL;
	TarotGameEvent* _tmp0_;
	gsize _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (e != NULL);
	_vala_assert (self->priv->m_n < ((gsize) 256), "m_n < m_data.length");
	i = (self->priv->m_head + self->priv->m_n) % 256;
	_tmp0_ = __vala_TarotGameEvent_copy0 (e);
	__vala_TarotGameEvent_free0 (self->priv->m_data[i]);
	self->priv->m_data[i] = _tmp0_;
	_tmp1_ = self->priv->m_n;
	self->priv->m_n = _tmp1_ + 1;
	if (_tmp1_ == ((gsize) 0)) {
		_vala_assert (!self->priv->timer_running, "!timer_running");
		tarot_event_queue_start_timer (self);
	}
}

void
tarot_event_queue_close (TarotEventQueue* self)
{
	g_return_if_fail (self != NULL);
	self->priv->deleted = TRUE;
}

gboolean
tarot_event_queue_empty (TarotEventQueue* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->m_n == ((gsize) 0);
	return result;
}

TarotEventQueue*
tarot_event_queue_construct (GType object_type)
{
	TarotEventQueue* self = NULL;
	self = (TarotEventQueue*) g_type_create_instance (object_type);
	return self;
}

TarotEventQueue*
tarot_event_queue_new (void)
{
	return tarot_event_queue_construct (TAROT_TYPE_EVENT_QUEUE);
}

static void
tarot_value_event_queue_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
tarot_value_event_queue_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		tarot_event_queue_unref (value->data[0].v_pointer);
	}
}

static void
tarot_value_event_queue_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = tarot_event_queue_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
tarot_value_event_queue_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
tarot_value_event_queue_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		TarotEventQueue * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = tarot_event_queue_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
tarot_value_event_queue_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	TarotEventQueue ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = tarot_event_queue_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
tarot_param_spec_event_queue (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	TarotParamSpecEventQueue* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TAROT_TYPE_EVENT_QUEUE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
tarot_value_get_event_queue (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TAROT_TYPE_EVENT_QUEUE), NULL);
	return value->data[0].v_pointer;
}

void
tarot_value_set_event_queue (GValue* value,
                             gpointer v_object)
{
	TarotEventQueue * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TAROT_TYPE_EVENT_QUEUE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TAROT_TYPE_EVENT_QUEUE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		tarot_event_queue_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		tarot_event_queue_unref (old);
	}
}

void
tarot_value_take_event_queue (GValue* value,
                              gpointer v_object)
{
	TarotEventQueue * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TAROT_TYPE_EVENT_QUEUE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TAROT_TYPE_EVENT_QUEUE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		tarot_event_queue_unref (old);
	}
}

static void
tarot_event_queue_class_init (TarotEventQueueClass * klass,
                              gpointer klass_data)
{
	tarot_event_queue_parent_class = g_type_class_peek_parent (klass);
	((TarotEventQueueClass *) klass)->finalize = tarot_event_queue_finalize;
	g_type_class_adjust_private_offset (klass, &TarotEventQueue_private_offset);
	tarot_event_queue_signals[TAROT_EVENT_QUEUE_NEW_EVENT_SIGNAL] = g_signal_new ("new-event", TAROT_TYPE_EVENT_QUEUE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, tarot_game_event_get_type ());
	tarot_event_queue_signals[TAROT_EVENT_QUEUE_CATCHUP_SIGNAL] = g_signal_new ("catchup", TAROT_TYPE_EVENT_QUEUE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
tarot_event_queue_instance_init (TarotEventQueue * self,
                                 gpointer klass)
{
	self->priv = tarot_event_queue_get_instance_private (self);
	self->priv->timer_running = FALSE;
	self->priv->deleted = FALSE;
	self->priv->next_delay = (gdouble) 0;
	self->ref_count = 1;
}

static void
tarot_event_queue_finalize (TarotEventQueue * obj)
{
	TarotEventQueue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_EVENT_QUEUE, TarotEventQueue);
	g_signal_handlers_destroy (self);
	_vala_array_destroy (self->priv->m_data, 256, (GDestroyNotify) _vala_TarotGameEvent_free);
}

static GType
tarot_event_queue_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { tarot_value_event_queue_init, tarot_value_event_queue_free_value, tarot_value_event_queue_copy_value, tarot_value_event_queue_peek_pointer, "p", tarot_value_event_queue_collect_value, "p", tarot_value_event_queue_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (TarotEventQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_event_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotEventQueue), 0, (GInstanceInitFunc) tarot_event_queue_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType tarot_event_queue_type_id;
	tarot_event_queue_type_id = g_type_register_fundamental (g_type_fundamental_next (), "TarotEventQueue", &g_define_type_info, &g_define_type_fundamental_info, 0);
	TarotEventQueue_private_offset = g_type_add_instance_private (tarot_event_queue_type_id, sizeof (TarotEventQueuePrivate));
	return tarot_event_queue_type_id;
}

GType
tarot_event_queue_get_type (void)
{
	static volatile gsize tarot_event_queue_type_id__once = 0;
	if (g_once_init_enter (&tarot_event_queue_type_id__once)) {
		GType tarot_event_queue_type_id;
		tarot_event_queue_type_id = tarot_event_queue_get_type_once ();
		g_once_init_leave (&tarot_event_queue_type_id__once, tarot_event_queue_type_id);
	}
	return tarot_event_queue_type_id__once;
}

gpointer
tarot_event_queue_ref (gpointer instance)
{
	TarotEventQueue * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
tarot_event_queue_unref (gpointer instance)
{
	TarotEventQueue * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		TAROT_EVENT_QUEUE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
tarot_window_get_instance_private (TarotWindow* self)
{
	return G_STRUCT_MEMBER_P (self, TarotWindow_private_offset);
}

static void
_vala_TarotSolo_free (TarotSolo* self)
{
	g_boxed_free (tarot_solo_get_type (), self);
}

static void
_vala_TarotGame_free (TarotGame* self)
{
	g_boxed_free (tarot_game_get_type (), self);
}

static void
_vala_TarotGameIterator_free (TarotGameIterator* self)
{
	g_boxed_free (tarot_game_iterator_get_type (), self);
}

static void
tarot_window_update_events (TarotWindow* self)
{
	gsize i = 0UL;
	TarotGame* game = NULL;
	TarotSolo* _tmp0_;
	TarotGame* _tmp1_;
	g_return_if_fail (self != NULL);
	i = (gsize) 0;
	_tmp0_ = self->priv->my_game;
	_tmp1_ = tarot_solo_get_alloc (_tmp0_);
	game = _tmp1_;
	{
		TarotGameIterator* _e_it = NULL;
		TarotGame* _tmp2_;
		TarotGameIterator* _tmp3_;
		TarotGameEvent* e = NULL;
		_tmp2_ = game;
		_tmp3_ = tarot_game_iterator (_tmp2_);
		_e_it = _tmp3_;
		while (TRUE) {
			TarotGameIterator* _tmp4_;
			TarotGameEvent* _tmp5_;
			TarotGameEvent* _tmp6_;
			gsize _tmp10_;
			_tmp4_ = _e_it;
			_tmp5_ = tarot_game_iterator_next_value (_tmp4_);
			e = _tmp5_;
			_tmp6_ = e;
			if (!(_tmp6_ != NULL)) {
				break;
			}
			if (i >= self->priv->n_events_pulled) {
				TarotEventQueue* _tmp7_;
				TarotGameEvent* _tmp8_;
				gsize _tmp9_;
				_tmp7_ = self->priv->m_queue;
				_tmp8_ = e;
				tarot_event_queue_enqueue (_tmp7_, _tmp8_);
				_tmp9_ = self->priv->n_events_pulled;
				self->priv->n_events_pulled = _tmp9_ + 1;
			}
			_tmp10_ = i;
			i = _tmp10_ + 1;
		}
		__vala_TarotGameIterator_free0 (_e_it);
	}
	tarot_window_check_if_next (self);
	__vala_TarotGame_free0 (game);
}

static void
tarot_window_on_server_event (TarotWindow* self,
                              TarotGameEvent* ev)
{
	TarotGame* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ev != NULL);
	_tmp0_ = self->priv->game_shown;
	if (tarot_game_add_event (_tmp0_, ev) != TAROT_GAME_OK) {
		_vala_assert (FALSE, "false");
	}
	tarot_window_update_events (self);
}

static void
_tarot_window_on_server_event_tarot_event_queue_new_event (TarotEventQueue* _sender,
                                                           TarotGameEvent* e,
                                                           gpointer self)
{
	tarot_window_on_server_event ((TarotWindow*) self, e);
}

static void
__lambda31_ (TarotWindow* self)
{
	tarot_window_check_if_next (self);
}

static void
___lambda31__tarot_event_queue_catchup (TarotEventQueue* _sender,
                                        gpointer self)
{
	__lambda31_ ((TarotWindow*) self);
}

static void
tarot_window_show_new_game_page (TarotWindow* self)
{
	TarotEventQueue* _tmp0_;
	TarotEventQueue* _tmp1_;
	TarotEventQueue* _tmp2_;
	TarotEventQueue* _tmp3_;
	GtkStack* _tmp4_;
	GtkListBox* _tmp5_;
	GtkButton* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->m_queue;
	tarot_event_queue_close (_tmp0_);
	_tmp1_ = tarot_event_queue_new ();
	_tarot_event_queue_unref0 (self->priv->m_queue);
	self->priv->m_queue = _tmp1_;
	_tmp2_ = self->priv->m_queue;
	g_signal_connect_object (_tmp2_, "new-event", (GCallback) _tarot_window_on_server_event_tarot_event_queue_new_event, self, 0);
	_tmp3_ = self->priv->m_queue;
	g_signal_connect_object (_tmp3_, "catchup", (GCallback) ___lambda31__tarot_event_queue_catchup, self, 0);
	_tmp4_ = self->priv->pages;
	_tmp5_ = self->priv->page_select_players;
	gtk_stack_set_visible_child (_tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->button_new_game;
	gtk_widget_hide ((GtkWidget*) _tmp6_);
}

static void
_tarot_window_show_new_game_page_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
	tarot_window_show_new_game_page ((TarotWindow*) self);
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
	result = _tmp0_;
	return result;
}

static void
tarot_window_new_game_3p (TarotWindow* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_date_time_new_now_utc ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_to_string (_tmp1_);
	tarot_window_start_new_game (self, (gsize) 3, FALSE, _tmp2_);
	_g_date_time_unref0 (_tmp1_);
}

static void
_tarot_window_new_game_3p_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_window_new_game_3p ((TarotWindow*) self);
}

static void
tarot_window_new_game_4p (TarotWindow* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_date_time_new_now_utc ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_to_string (_tmp1_);
	tarot_window_start_new_game (self, (gsize) 4, FALSE, _tmp2_);
	_g_date_time_unref0 (_tmp1_);
}

static void
_tarot_window_new_game_4p_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_window_new_game_4p ((TarotWindow*) self);
}

static void
tarot_window_new_game_5p (TarotWindow* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_date_time_new_now_utc ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_to_string (_tmp1_);
	tarot_window_start_new_game (self, (gsize) 5, TRUE, _tmp2_);
	_g_date_time_unref0 (_tmp1_);
}

static void
_tarot_window_new_game_5p_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self)
{
	tarot_window_new_game_5p ((TarotWindow*) self);
}

static void
tarot_window_open_info_dialog (TarotWindow* self)
{
	gchar** artists = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint artists_length1;
	gint _artists_size_;
	gchar** authors = NULL;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint authors_length1;
	gint _authors_size_;
	gchar* comments = NULL;
	gchar* _tmp4_;
	gchar* copyright = NULL;
	gchar* _tmp5_;
	gchar** documenters = NULL;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint documenters_length1;
	gint _documenters_size_;
	GtkLicense license_type = 0;
	gchar* program_name = NULL;
	gchar* _tmp8_;
	gchar* version = NULL;
	gchar* _tmp9_;
	gchar* website = NULL;
	gchar* _tmp10_;
	gchar* logo_icon_name = NULL;
	gchar* _tmp11_;
	GtkPopoverMenu* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup ("Individu Masqué");
	_tmp1_ = g_new0 (gchar*, 2 + 1);
	_tmp1_[0] = _tmp0_;
	_tmp1_[1] = NULL;
	artists = _tmp1_;
	artists_length1 = 2;
	_artists_size_ = artists_length1;
	_tmp2_ = g_strdup ("Vivien Kraus");
	_tmp3_ = g_new0 (gchar*, 2 + 1);
	_tmp3_[0] = _tmp2_;
	_tmp3_[1] = NULL;
	authors = _tmp3_;
	authors_length1 = 2;
	_authors_size_ = authors_length1;
	_tmp4_ = g_strdup ("");
	comments = _tmp4_;
	_tmp5_ = g_strdup (_ ("Copyright © 2019, 2020 Vivien Kraus"));
	copyright = _tmp5_;
	_tmp6_ = g_strdup ("Guess Who");
	_tmp7_ = g_new0 (gchar*, 2 + 1);
	_tmp7_[0] = _tmp6_;
	_tmp7_[1] = NULL;
	documenters = _tmp7_;
	documenters_length1 = 2;
	_documenters_size_ = documenters_length1;
	license_type = GTK_LICENSE_GPL_3_0;
	_tmp8_ = g_strdup ("eu.planete_kraus.Tarot");
	program_name = _tmp8_;
	_tmp9_ = g_strdup (VERSION);
	version = _tmp9_;
	_tmp10_ = g_strdup ("https://play-tarot.frama.io/tarot");
	website = _tmp10_;
	_tmp11_ = g_strdup ("eu.planete_kraus.Tarot");
	logo_icon_name = _tmp11_;
	gtk_show_about_dialog ((GtkWindow*) self, "artists", artists, "authors", authors, "comments", comments, "copyright", copyright, "documenters", documenters, "license-type", license_type, "program-name", program_name, "version", version, "website", website, "logo-icon-name", logo_icon_name, NULL, NULL);
	_tmp12_ = self->priv->menu_popover;
	gtk_widget_hide ((GtkWidget*) _tmp12_);
	_g_free0 (logo_icon_name);
	_g_free0 (website);
	_g_free0 (version);
	_g_free0 (program_name);
	documenters = (_vala_array_free (documenters, documenters_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (copyright);
	_g_free0 (comments);
	authors = (_vala_array_free (authors, authors_length1, (GDestroyNotify) g_free), NULL);
	artists = (_vala_array_free (artists, artists_length1, (GDestroyNotify) g_free), NULL);
}

static void
_tarot_window_open_info_dialog_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
	tarot_window_open_info_dialog ((TarotWindow*) self);
}

static void
tarot_window_show_menu_popover (TarotWindow* self)
{
	GtkPopoverMenu* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->menu_popover;
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
}

static void
_tarot_window_show_menu_popover_gtk_button_clicked (GtkButton* _sender,
                                                    gpointer self)
{
	tarot_window_show_menu_popover ((TarotWindow*) self);
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static void
tarot_window_check_if_next (TarotWindow* self)
{
	TarotWidget* _tmp0_;
	TarotGame* _tmp1_;
	TarotWidget* _tmp2_;
	TarotEventQueue* _tmp3_;
	TarotPlayer myself = 0U;
	TarotGame* _tmp4_;
	TarotPlayer _tmp5_ = 0U;
	TarotGameError _tmp6_;
	TarotPlayer next = 0U;
	TarotBid mini = 0;
	gboolean _tmp7_ = FALSE;
	TarotGame* _tmp8_;
	TarotPlayer _tmp9_ = 0U;
	TarotBid _tmp10_ = 0;
	TarotGameError _tmp11_;
	gboolean allowed = FALSE;
	gboolean _tmp17_ = FALSE;
	TarotGame* _tmp18_;
	TarotPlayer _tmp19_ = 0U;
	gboolean _tmp20_ = FALSE;
	TarotGameError _tmp21_;
	TarotNumber mini_call = 0U;
	gboolean _tmp28_ = FALSE;
	TarotGame* _tmp29_;
	TarotPlayer _tmp30_ = 0U;
	TarotNumber _tmp31_ = 0U;
	TarotGameError _tmp32_;
	gsize n_discard = 0UL;
	TarotCard* prio = NULL;
	gint prio_length1 = 0;
	gint _prio_size_ = 0;
	TarotCard* additional = NULL;
	gint additional_length1 = 0;
	gint _additional_size_ = 0;
	gboolean _tmp39_ = FALSE;
	TarotGame* _tmp40_;
	TarotPlayer _tmp41_ = 0U;
	gsize _tmp42_ = 0UL;
	TarotCard* _tmp43_ = NULL;
	gsize _tmp44_ = 0;
	TarotCard* _tmp45_ = NULL;
	gsize _tmp46_ = 0;
	TarotGameError _tmp47_;
	gsize n_simple = 0UL;
	gsize n_double = 0UL;
	gsize n_triple = 0UL;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp53_ = FALSE;
	TarotGame* _tmp54_;
	TarotPlayer _tmp55_ = 0U;
	gsize _tmp56_ = 0UL;
	gsize _tmp57_ = 0UL;
	gsize _tmp58_ = 0UL;
	TarotCard* _tmp59_ = NULL;
	gsize _tmp60_ = 0;
	TarotCard* _tmp61_ = NULL;
	gsize _tmp62_ = 0;
	TarotGameError _tmp63_;
	TarotCard* playable = NULL;
	gint playable_length1 = 0;
	gint _playable_size_ = 0;
	gboolean _tmp70_ = FALSE;
	TarotGame* _tmp71_;
	TarotPlayer _tmp72_ = 0U;
	TarotCard* _tmp73_ = NULL;
	gsize _tmp74_ = 0;
	TarotGameError _tmp75_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tarot_widget;
	_tmp1_ = self->priv->game_shown;
	tarot_widget_set_game (_tmp0_, _tmp1_);
	_tmp2_ = self->priv->tarot_widget;
	tarot_widget_dont_ask (_tmp2_);
	_tmp3_ = self->priv->m_queue;
	if (!tarot_event_queue_empty (_tmp3_)) {
		return;
	}
	myself = (TarotPlayer) -1;
	_tmp4_ = self->priv->game_shown;
	_tmp6_ = tarot_game_get_main_player (_tmp4_, &_tmp5_);
	myself = _tmp5_;
	if (_tmp6_ != TAROT_GAME_OK) {
		_vala_assert (FALSE, "false");
	}
	_tmp8_ = self->priv->game_shown;
	_tmp11_ = tarot_game_get_hint_bid (_tmp8_, &_tmp9_, &_tmp10_);
	next = _tmp9_;
	mini = _tmp10_;
	if (_tmp11_ == TAROT_GAME_OK) {
		_tmp7_ = next == myself;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		FILE* _tmp12_;
		GEnumValue* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		TarotWidget* _tmp16_;
		_tmp12_ = stderr;
		_tmp13_ = g_enum_get_value (g_type_class_ref (tarot_bid_get_type ()), mini);
		_tmp14_ = g_strdup_printf ("Asking bid >= %s\n", (_tmp13_ != NULL) ? _tmp13_->value_name : NULL);
		_tmp15_ = _tmp14_;
		fprintf (_tmp12_, "%s", _tmp15_);
		_g_free0 (_tmp15_);
		_tmp16_ = self->priv->tarot_widget;
		tarot_widget_ask_bid (_tmp16_, mini);
	}
	_tmp18_ = self->priv->game_shown;
	_tmp21_ = tarot_game_get_hint_decl (_tmp18_, &_tmp19_, &_tmp20_);
	next = _tmp19_;
	allowed = _tmp20_;
	if (_tmp21_ == TAROT_GAME_OK) {
		_tmp17_ = next == myself;
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		FILE* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		TarotWidget* _tmp27_;
		_tmp22_ = stderr;
		_tmp23_ = bool_to_string (allowed);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strdup_printf ("Asking declaration <= %s\n", _tmp24_);
		_tmp26_ = _tmp25_;
		fprintf (_tmp22_, "%s", _tmp26_);
		_g_free0 (_tmp26_);
		_g_free0 (_tmp24_);
		_tmp27_ = self->priv->tarot_widget;
		tarot_widget_ask_declaration (_tmp27_, allowed);
	}
	_tmp29_ = self->priv->game_shown;
	_tmp32_ = tarot_game_get_hint_call (_tmp29_, &_tmp30_, &_tmp31_);
	next = _tmp30_;
	mini_call = _tmp31_;
	if (_tmp32_ == TAROT_GAME_OK) {
		_tmp28_ = next == myself;
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		FILE* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		TarotWidget* _tmp38_;
		_tmp33_ = stderr;
		_tmp34_ = g_strdup_printf ("%u", (guint) mini_call);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_strdup_printf ("Asking call <= %s\n", _tmp35_);
		_tmp37_ = _tmp36_;
		fprintf (_tmp33_, "%s", _tmp37_);
		_g_free0 (_tmp37_);
		_g_free0 (_tmp35_);
		_tmp38_ = self->priv->tarot_widget;
		tarot_widget_ask_call (_tmp38_, mini_call);
	}
	_tmp40_ = self->priv->game_shown;
	_tmp47_ = tarot_game_get_hint_discard_alloc (_tmp40_, &_tmp41_, &_tmp42_, &_tmp44_, &_tmp43_, &_tmp46_, &_tmp45_);
	next = _tmp41_;
	n_discard = _tmp42_;
	prio = (g_free (prio), NULL);
	prio = _tmp43_;
	prio_length1 = _tmp44_;
	_prio_size_ = prio_length1;
	additional = (g_free (additional), NULL);
	additional = _tmp45_;
	additional_length1 = _tmp46_;
	_additional_size_ = additional_length1;
	if (_tmp47_ == TAROT_GAME_OK) {
		_tmp39_ = next == myself;
	} else {
		_tmp39_ = FALSE;
	}
	if (_tmp39_) {
		FILE* _tmp48_;
		TarotWidget* _tmp49_;
		TarotCard* _tmp50_;
		gint _tmp50__length1;
		TarotCard* _tmp51_;
		gint _tmp51__length1;
		_tmp48_ = stderr;
		fprintf (_tmp48_, "Asking discard: %lu cards\n", (gulong) n_discard);
		_tmp49_ = self->priv->tarot_widget;
		_tmp50_ = prio;
		_tmp50__length1 = prio_length1;
		_tmp51_ = additional;
		_tmp51__length1 = additional_length1;
		tarot_widget_ask_discard (_tmp49_, n_discard, _tmp50_, (gint) _tmp50__length1, _tmp51_, (gint) _tmp51__length1);
	}
	_tmp54_ = self->priv->game_shown;
	_tmp63_ = tarot_game_get_hint_handful_alloc (_tmp54_, &_tmp55_, &_tmp56_, &_tmp57_, &_tmp58_, &_tmp60_, &_tmp59_, &_tmp62_, &_tmp61_);
	next = _tmp55_;
	n_simple = _tmp56_;
	n_double = _tmp57_;
	n_triple = _tmp58_;
	prio = (g_free (prio), NULL);
	prio = _tmp59_;
	prio_length1 = _tmp60_;
	_prio_size_ = prio_length1;
	additional = (g_free (additional), NULL);
	additional = _tmp61_;
	additional_length1 = _tmp62_;
	_additional_size_ = additional_length1;
	if (_tmp63_ == TAROT_GAME_OK) {
		_tmp53_ = next == myself;
	} else {
		_tmp53_ = FALSE;
	}
	if (_tmp53_) {
		TarotCard* _tmp64_;
		gint _tmp64__length1;
		TarotCard* _tmp65_;
		gint _tmp65__length1;
		_tmp64_ = prio;
		_tmp64__length1 = prio_length1;
		_tmp65_ = additional;
		_tmp65__length1 = additional_length1;
		_tmp52_ = n_simple <= ((gsize) (_tmp64__length1 + _tmp65__length1));
	} else {
		_tmp52_ = FALSE;
	}
	if (_tmp52_) {
		FILE* _tmp66_;
		TarotWidget* _tmp67_;
		TarotCard* _tmp68_;
		gint _tmp68__length1;
		TarotCard* _tmp69_;
		gint _tmp69__length1;
		_tmp66_ = stderr;
		fprintf (_tmp66_, "Asking handful: %lu, %lu or %lu cards\n", (gulong) n_simple, (gulong) n_double, (gulong) n_triple);
		_tmp67_ = self->priv->tarot_widget;
		_tmp68_ = prio;
		_tmp68__length1 = prio_length1;
		_tmp69_ = additional;
		_tmp69__length1 = additional_length1;
		tarot_widget_ask_handful (_tmp67_, n_simple, n_double, n_triple, _tmp68_, (gint) _tmp68__length1, _tmp69_, (gint) _tmp69__length1);
	}
	_tmp71_ = self->priv->game_shown;
	_tmp75_ = tarot_game_get_hint_card_alloc (_tmp71_, &_tmp72_, &_tmp74_, &_tmp73_);
	next = _tmp72_;
	playable = (g_free (playable), NULL);
	playable = _tmp73_;
	playable_length1 = _tmp74_;
	_playable_size_ = playable_length1;
	if (_tmp75_ == TAROT_GAME_OK) {
		_tmp70_ = next == myself;
	} else {
		_tmp70_ = FALSE;
	}
	if (_tmp70_) {
		FILE* _tmp76_;
		TarotWidget* _tmp77_;
		TarotCard* _tmp78_;
		gint _tmp78__length1;
		_tmp76_ = stderr;
		fprintf (_tmp76_, "Asking card");
		_tmp77_ = self->priv->tarot_widget;
		_tmp78_ = playable;
		_tmp78__length1 = playable_length1;
		tarot_widget_ask_play (_tmp77_, _tmp78_, (gint) _tmp78__length1);
	}
	playable = (g_free (playable), NULL);
	additional = (g_free (additional), NULL);
	prio = (g_free (prio), NULL);
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static void
tarot_window_start_new_game (TarotWindow* self,
                             gsize n_players,
                             gboolean with_call,
                             gchar* seed)
{
	TarotGame* _tmp0_;
	gsize retry = 0UL;
	gboolean ok = FALSE;
	GtkStack* _tmp18_;
	TarotWidget* _tmp19_;
	GtkButton* _tmp20_;
	TarotWidget* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (seed != NULL);
	self->priv->n_events_pulled = (gsize) 0;
	_tmp0_ = tarot_game_alloc ();
	__vala_TarotGame_free0 (self->priv->game_shown);
	self->priv->game_shown = _tmp0_;
	retry = (gsize) 0;
	ok = FALSE;
	while (TRUE) {
		gchar* my_seed = NULL;
		gchar* _tmp1_;
		gchar* bytes = NULL;
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gint bytes_length1;
		gint _bytes_size_;
		gchar* _tmp13_;
		gint _tmp13__length1;
		TarotSolo* _tmp14_;
		gsize _tmp15_;
		TarotSolo* _tmp16_;
		gchar* _tmp17_;
		gint _tmp17__length1;
		if (!(!ok)) {
			break;
		}
		_tmp1_ = g_strdup_printf ("%s (%lu)", seed, (gulong) retry);
		my_seed = _tmp1_;
		_tmp2_ = my_seed;
		_tmp3_ = strlen (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_new0 (gchar, _tmp4_);
		bytes = _tmp5_;
		bytes_length1 = _tmp4_;
		_bytes_size_ = bytes_length1;
		{
			glong i = 0L;
			i = (glong) 0;
			{
				gboolean _tmp6_ = FALSE;
				_tmp6_ = TRUE;
				while (TRUE) {
					const gchar* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					gchar* _tmp11_;
					gint _tmp11__length1;
					const gchar* _tmp12_;
					if (!_tmp6_) {
						glong _tmp7_;
						_tmp7_ = i;
						i = _tmp7_ + 1;
					}
					_tmp6_ = FALSE;
					_tmp8_ = my_seed;
					_tmp9_ = strlen (_tmp8_);
					_tmp10_ = _tmp9_;
					if (!(i < ((glong) _tmp10_))) {
						break;
					}
					_tmp11_ = bytes;
					_tmp11__length1 = bytes_length1;
					_tmp12_ = my_seed;
					_tmp11_[i] = string_get (_tmp12_, i);
				}
			}
		}
		_tmp13_ = bytes;
		_tmp13__length1 = bytes_length1;
		_tmp14_ = tarot_solo_alloc_fuzzy (0.05, _tmp13__length1, _tmp13_, NULL);
		__vala_TarotSolo_free0 (self->priv->my_game);
		self->priv->my_game = _tmp14_;
		_tmp15_ = retry;
		retry = _tmp15_ + 1;
		_tmp16_ = self->priv->my_game;
		_tmp17_ = bytes;
		_tmp17__length1 = bytes_length1;
		ok = tarot_solo_setup_random (_tmp16_, n_players, with_call, (gsize) _tmp17__length1, _tmp17_) == TAROT_GAME_OK;
		bytes = (g_free (bytes), NULL);
		_g_free0 (my_seed);
	}
	_tmp18_ = self->priv->pages;
	_tmp19_ = self->priv->tarot_widget;
	gtk_stack_set_visible_child (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->button_new_game;
	gtk_widget_show ((GtkWidget*) _tmp20_);
	_tmp21_ = self->priv->tarot_widget;
	tarot_widget_dont_ask (_tmp21_);
	tarot_window_update_events (self);
	_g_free0 (seed);
}

static gboolean
tarot_window_starts_with (const gchar* s,
                          const gchar* prefix)
{
	gboolean result;
	g_return_val_if_fail (s != NULL, FALSE);
	g_return_val_if_fail (prefix != NULL, FALSE);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				gint _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = strlen (prefix);
				_tmp3_ = _tmp2_;
				if (!(i < _tmp3_)) {
					break;
				}
				if (string_get (s, (glong) i) != string_get (prefix, (glong) i)) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

TarotWindow*
tarot_window_construct (GType object_type,
                        GtkApplication* app)
{
	TarotWindow * self = NULL;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp2_;
	g_return_val_if_fail (app != NULL, NULL);
	self = (TarotWindow*) g_object_new (object_type, "application", app, NULL);
	_tmp0_ = gdk_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = gtk_css_provider_new ();
	provider = _tmp2_;
	gtk_css_provider_load_from_resource (provider, "/eu/planete_kraus/Tarot/style.css");
	gtk_style_context_add_provider_for_screen (screen, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	tarot_window_show_new_game_page (self);
	_g_object_unref0 (provider);
	_g_object_unref0 (screen);
	return self;
}

TarotWindow*
tarot_window_new (GtkApplication* app)
{
	return tarot_window_construct (TAROT_TYPE_WINDOW, app);
}

static void
_tarot_window___lambda32_ (TarotWindow* self,
                           TarotBid bid)
{
	FILE* _tmp0_;
	GEnumValue* _tmp1_;
	TarotSolo* _tmp2_;
	TarotGameEvent* _tmp3_;
	TarotGameEvent* _tmp4_;
	gboolean _tmp5_;
	_tmp0_ = stderr;
	_tmp1_ = g_enum_get_value (g_type_class_ref (tarot_bid_get_type ()), bid);
	fprintf (_tmp0_, "Selected bid %s\n", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
	_tmp2_ = self->priv->my_game;
	_tmp3_ = tarot_game_event_alloc_bid (bid);
	_tmp4_ = _tmp3_;
	_tmp5_ = tarot_solo_add (_tmp2_, _tmp4_) != TAROT_GAME_OK;
	__vala_TarotGameEvent_free0 (_tmp4_);
	if (_tmp5_) {
		_vala_assert (FALSE, "false");
	}
	tarot_window_update_events (self);
}

static void
__tarot_window___lambda32__tarot_widget_select_bid (TarotWidget* _sender,
                                                    TarotBid bid,
                                                    gpointer self)
{
	_tarot_window___lambda32_ ((TarotWindow*) self, bid);
}

static void
_tarot_window___lambda33_ (TarotWindow* self,
                           gboolean decl)
{
	FILE* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	TarotSolo* _tmp3_;
	TarotGameEvent* _tmp4_;
	TarotGameEvent* _tmp5_;
	gboolean _tmp6_;
	_tmp0_ = stderr;
	_tmp1_ = bool_to_string (decl);
	_tmp2_ = _tmp1_;
	fprintf (_tmp0_, "Selected decl %s\n", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->my_game;
	_tmp4_ = tarot_game_event_alloc_decl (decl);
	_tmp5_ = _tmp4_;
	_tmp6_ = tarot_solo_add (_tmp3_, _tmp5_) != TAROT_GAME_OK;
	__vala_TarotGameEvent_free0 (_tmp5_);
	if (_tmp6_) {
		_vala_assert (FALSE, "false");
	}
	tarot_window_update_events (self);
}

static void
__tarot_window___lambda33__tarot_widget_select_declaration (TarotWidget* _sender,
                                                            gboolean decl,
                                                            gpointer self)
{
	_tarot_window___lambda33_ ((TarotWindow*) self, decl);
}

static void
_tarot_window___lambda34_ (TarotWindow* self,
                           guint card)
{
	FILE* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	TarotSolo* _tmp3_;
	TarotGameEvent* _tmp4_;
	TarotGameEvent* _tmp5_;
	gboolean _tmp6_;
	_tmp0_ = stderr;
	_tmp1_ = tarot_card_to_string_alloc ((TarotCard) card);
	_tmp2_ = _tmp1_;
	fprintf (_tmp0_, "Selected call %s\n", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->my_game;
	_tmp4_ = tarot_game_event_alloc_call ((TarotCard) card);
	_tmp5_ = _tmp4_;
	_tmp6_ = tarot_solo_add (_tmp3_, _tmp5_) != TAROT_GAME_OK;
	__vala_TarotGameEvent_free0 (_tmp5_);
	if (_tmp6_) {
		_vala_assert (FALSE, "false");
	}
	tarot_window_update_events (self);
}

static void
__tarot_window___lambda34__tarot_widget_select_call (TarotWidget* _sender,
                                                     guint call,
                                                     gpointer self)
{
	_tarot_window___lambda34_ ((TarotWindow*) self, call);
}

static void
_tarot_window___lambda35_ (TarotWindow* self,
                           guint* cards,
                           gint cards_length1)
{
	FILE* _tmp0_;
	TarotCard* discard_cards = NULL;
	TarotCard* _tmp1_;
	gint discard_cards_length1;
	gint _discard_cards_size_;
	TarotSolo* _tmp6_;
	TarotCard* _tmp7_;
	gint _tmp7__length1;
	TarotGameEvent* _tmp8_;
	TarotGameEvent* _tmp9_;
	gboolean _tmp10_;
	_tmp0_ = stderr;
	fprintf (_tmp0_, "Selected discard\n");
	_tmp1_ = g_new0 (TarotCard, cards_length1);
	discard_cards = _tmp1_;
	discard_cards_length1 = cards_length1;
	_discard_cards_size_ = discard_cards_length1;
	{
		gsize i = 0UL;
		i = (gsize) 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				TarotCard* _tmp4_;
				gint _tmp4__length1;
				guint _tmp5_;
				if (!_tmp2_) {
					gsize _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(i < ((gsize) cards_length1))) {
					break;
				}
				_tmp4_ = discard_cards;
				_tmp4__length1 = discard_cards_length1;
				_tmp5_ = cards[i];
				_tmp4_[i] = (TarotCard) _tmp5_;
			}
		}
	}
	_tmp6_ = self->priv->my_game;
	_tmp7_ = discard_cards;
	_tmp7__length1 = discard_cards_length1;
	_tmp8_ = tarot_game_event_alloc_discard (_tmp7__length1, _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = tarot_solo_add (_tmp6_, _tmp9_) != TAROT_GAME_OK;
	__vala_TarotGameEvent_free0 (_tmp9_);
	if (_tmp10_) {
		_vala_assert (FALSE, "false");
	}
	tarot_window_update_events (self);
	discard_cards = (g_free (discard_cards), NULL);
}

static void
__tarot_window___lambda35__tarot_widget_select_discard (TarotWidget* _sender,
                                                        guint* discard,
                                                        gint discard_length1,
                                                        gpointer self)
{
	_tarot_window___lambda35_ ((TarotWindow*) self, discard, discard_length1);
}

static void
_tarot_window___lambda36_ (TarotWindow* self,
                           guint* cards,
                           gint cards_length1)
{
	FILE* _tmp0_;
	TarotCard* handful_cards = NULL;
	TarotCard* _tmp1_;
	gint handful_cards_length1;
	gint _handful_cards_size_;
	TarotSolo* _tmp6_;
	TarotCard* _tmp7_;
	gint _tmp7__length1;
	TarotGameEvent* _tmp8_;
	TarotGameEvent* _tmp9_;
	gboolean _tmp10_;
	_tmp0_ = stderr;
	fprintf (_tmp0_, "Selected handful\n");
	_tmp1_ = g_new0 (TarotCard, cards_length1);
	handful_cards = _tmp1_;
	handful_cards_length1 = cards_length1;
	_handful_cards_size_ = handful_cards_length1;
	{
		gsize i = 0UL;
		i = (gsize) 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				TarotCard* _tmp4_;
				gint _tmp4__length1;
				guint _tmp5_;
				if (!_tmp2_) {
					gsize _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				if (!(i < ((gsize) cards_length1))) {
					break;
				}
				_tmp4_ = handful_cards;
				_tmp4__length1 = handful_cards_length1;
				_tmp5_ = cards[i];
				_tmp4_[i] = (TarotCard) _tmp5_;
			}
		}
	}
	_tmp6_ = self->priv->my_game;
	_tmp7_ = handful_cards;
	_tmp7__length1 = handful_cards_length1;
	_tmp8_ = tarot_game_event_alloc_handful (_tmp7__length1, _tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = tarot_solo_add (_tmp6_, _tmp9_) != TAROT_GAME_OK;
	__vala_TarotGameEvent_free0 (_tmp9_);
	if (_tmp10_) {
		_vala_assert (FALSE, "false");
	}
	tarot_window_update_events (self);
	handful_cards = (g_free (handful_cards), NULL);
}

static void
__tarot_window___lambda36__tarot_widget_select_handful (TarotWidget* _sender,
                                                        guint* handful,
                                                        gint handful_length1,
                                                        gpointer self)
{
	_tarot_window___lambda36_ ((TarotWindow*) self, handful, handful_length1);
}

static void
_tarot_window___lambda37_ (TarotWindow* self,
                           guint card)
{
	FILE* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	TarotSolo* _tmp3_;
	TarotGameEvent* _tmp4_;
	TarotGameEvent* _tmp5_;
	gboolean _tmp6_;
	TarotWidget* _tmp7_;
	_tmp0_ = stderr;
	_tmp1_ = tarot_card_to_string_alloc ((TarotCard) card);
	_tmp2_ = _tmp1_;
	fprintf (_tmp0_, "Selected card %s\n", _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->my_game;
	_tmp4_ = tarot_game_event_alloc_card ((TarotCard) card);
	_tmp5_ = _tmp4_;
	_tmp6_ = tarot_solo_add (_tmp3_, _tmp5_) != TAROT_GAME_OK;
	__vala_TarotGameEvent_free0 (_tmp5_);
	if (_tmp6_) {
		_vala_assert (FALSE, "false");
	}
	_tmp7_ = self->priv->tarot_widget;
	tarot_widget_dont_ask (_tmp7_);
	tarot_window_update_events (self);
}

static void
__tarot_window___lambda37__tarot_widget_select_card (TarotWidget* _sender,
                                                     guint card,
                                                     gpointer self)
{
	_tarot_window___lambda37_ ((TarotWindow*) self, card);
}

static GObject *
tarot_window_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TarotWindow * self;
	TarotEventQueue* _tmp0_;
	TarotWidget* _tmp1_;
	TarotWidget* _tmp2_;
	TarotWidget* _tmp3_;
	TarotWidget* _tmp4_;
	TarotWidget* _tmp5_;
	TarotWidget* _tmp6_;
	parent_class = G_OBJECT_CLASS (tarot_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_WINDOW, TarotWindow);
	_tmp0_ = tarot_event_queue_new ();
	_tarot_event_queue_unref0 (self->priv->m_queue);
	self->priv->m_queue = _tmp0_;
	_tmp1_ = self->priv->tarot_widget;
	g_signal_connect_object (_tmp1_, "select-bid", (GCallback) __tarot_window___lambda32__tarot_widget_select_bid, self, 0);
	_tmp2_ = self->priv->tarot_widget;
	g_signal_connect_object (_tmp2_, "select-declaration", (GCallback) __tarot_window___lambda33__tarot_widget_select_declaration, self, 0);
	_tmp3_ = self->priv->tarot_widget;
	g_signal_connect_object (_tmp3_, "select-call", (GCallback) __tarot_window___lambda34__tarot_widget_select_call, self, 0);
	_tmp4_ = self->priv->tarot_widget;
	g_signal_connect_object (_tmp4_, "select-discard", (GCallback) __tarot_window___lambda35__tarot_widget_select_discard, self, 0);
	_tmp5_ = self->priv->tarot_widget;
	g_signal_connect_object (_tmp5_, "select-handful", (GCallback) __tarot_window___lambda36__tarot_widget_select_handful, self, 0);
	_tmp6_ = self->priv->tarot_widget;
	g_signal_connect_object (_tmp6_, "select-card", (GCallback) __tarot_window___lambda37__tarot_widget_select_card, self, 0);
	return obj;
}

static void
tarot_window_class_init (TarotWindowClass * klass,
                         gpointer klass_data)
{
	tarot_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TarotWindow_private_offset);
	G_OBJECT_CLASS (klass)->constructor = tarot_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = tarot_window_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/eu/planete_kraus/Tarot/window.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "pages", FALSE, TarotWindow_private_offset + G_STRUCT_OFFSET (TarotWindowPrivate, pages));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tarot_widget", FALSE, TarotWindow_private_offset + G_STRUCT_OFFSET (TarotWindowPrivate, tarot_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_select_players", FALSE, TarotWindow_private_offset + G_STRUCT_OFFSET (TarotWindowPrivate, page_select_players));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_new_game", FALSE, TarotWindow_private_offset + G_STRUCT_OFFSET (TarotWindowPrivate, button_new_game));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "menu_popover", FALSE, TarotWindow_private_offset + G_STRUCT_OFFSET (TarotWindowPrivate, menu_popover));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "show_new_game_page", G_CALLBACK(_tarot_window_show_new_game_page_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "new_game_3p", G_CALLBACK(_tarot_window_new_game_3p_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "new_game_4p", G_CALLBACK(_tarot_window_new_game_4p_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "new_game_5p", G_CALLBACK(_tarot_window_new_game_5p_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "open_info_dialog", G_CALLBACK(_tarot_window_open_info_dialog_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "show_menu_popover", G_CALLBACK(_tarot_window_show_menu_popover_gtk_button_clicked));
}

static void
tarot_window_instance_init (TarotWindow * self,
                            gpointer klass)
{
	self->priv = tarot_window_get_instance_private (self);
	g_type_ensure (TAROT_TYPE_WIDGET);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
tarot_window_finalize (GObject * obj)
{
	TarotWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TAROT_TYPE_WINDOW, TarotWindow);
	__vala_TarotSolo_free0 (self->priv->my_game);
	_tarot_event_queue_unref0 (self->priv->m_queue);
	__vala_TarotGame_free0 (self->priv->game_shown);
	G_OBJECT_CLASS (tarot_window_parent_class)->finalize (obj);
}

static GType
tarot_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TarotWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tarot_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TarotWindow), 0, (GInstanceInitFunc) tarot_window_instance_init, NULL };
	GType tarot_window_type_id;
	tarot_window_type_id = g_type_register_static (gtk_application_window_get_type (), "TarotWindow", &g_define_type_info, 0);
	TarotWindow_private_offset = g_type_add_instance_private (tarot_window_type_id, sizeof (TarotWindowPrivate));
	return tarot_window_type_id;
}

GType
tarot_window_get_type (void)
{
	static volatile gsize tarot_window_type_id__once = 0;
	if (g_once_init_enter (&tarot_window_type_id__once)) {
		GType tarot_window_type_id;
		tarot_window_type_id = tarot_window_get_type_once ();
		g_once_init_leave (&tarot_window_type_id__once, tarot_window_type_id);
	}
	return tarot_window_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

